// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S120_Subjects.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class S120_Subjects extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1, 1
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\34\u0200\1\u0300\1\u0200\1\u0400\1\u0500\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\3\22\0\1\1"+
    "\1\0\1\4\3\0\1\5\1\0\2\6\2\0\2\6"+
    "\1\7\1\10\12\11\1\12\1\13\5\0\1\14\1\15"+
    "\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\21"+
    "\1\25\1\26\1\27\1\30\1\31\1\32\1\21\1\33"+
    "\1\34\1\35\1\36\1\37\1\40\2\21\1\41\1\42"+
    "\1\0\1\43\1\0\1\44\1\0\1\45\1\46\1\47"+
    "\1\50\1\51\1\52\1\53\1\54\1\55\1\52\1\56"+
    "\1\57\1\60\1\61\1\62\1\63\1\52\1\64\1\65"+
    "\1\66\1\67\1\70\1\71\2\52\1\72\105\0\6\52"+
    "\1\0\11\52\1\0\6\52\2\0\4\52\3\0\6\52"+
    "\1\0\11\52\1\0\6\52\2\0\4\52\53\0\2\52"+
    "\6\0\2\73\66\0\2\52\4\0\2\52\17\0\1\74"+
    "\u0188\0\2\52\216\0\2\52\42\0\2\52\104\0\1\1"+
    "\20\0\2\6\u0115\0\1\75\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\2\0\6\1\2\2\60\0\3\3\1\0\1\3\5\0"+
    "\3\4\16\0\1\5\45\0\3\6\1\0\1\6\3\7"+
    "\36\0\1\10\17\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[177];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\76\0\174\0\272\0\370\0\u0136\0\u0174\0\u01b2"+
    "\0\370\0\u01f0\0\u022e\0\u026c\0\u02aa\0\u02e8\0\u0326\0\u0364"+
    "\0\u03a2\0\174\0\u03e0\0\u041e\0\u045c\0\u049a\0\u04d8\0\u0516"+
    "\0\u0554\0\u0592\0\u05d0\0\u060e\0\u064c\0\u068a\0\u06c8\0\u0706"+
    "\0\u0744\0\u0782\0\u07c0\0\u07fe\0\u083c\0\u087a\0\u08b8\0\u08f6"+
    "\0\u0934\0\u0972\0\u09b0\0\u09ee\0\u0a2c\0\u0a6a\0\u0aa8\0\u0ae6"+
    "\0\u0b24\0\u0b62\0\u0ba0\0\u0bde\0\u0c1c\0\u0c5a\0\u0c98\0\u0cd6"+
    "\0\u0d14\0\u0d52\0\370\0\u0d90\0\u0dce\0\u0e0c\0\u0e0c\0\u0e4a"+
    "\0\u0e88\0\u0ec6\0\u0f04\0\u0f42\0\370\0\u0f80\0\u0fbe\0\u0ffc"+
    "\0\u103a\0\u1078\0\u10b6\0\u10f4\0\u1132\0\u1170\0\u11ae\0\u11ec"+
    "\0\u122a\0\u1268\0\u12a6\0\u12e4\0\u1322\0\370\0\u1360\0\u139e"+
    "\0\u13dc\0\u141a\0\u1458\0\u1496\0\u14d4\0\u1512\0\u1550\0\u158e"+
    "\0\u15cc\0\u160a\0\u1648\0\u1686\0\u16c4\0\u1702\0\u1740\0\u177e"+
    "\0\u17bc\0\u17fa\0\u1838\0\u0dce\0\u1876\0\u18b4\0\u0fbe\0\u18f2"+
    "\0\u1930\0\u196e\0\u19ac\0\u19ea\0\u1a28\0\u1a66\0\u1aa4\0\u1ae2"+
    "\0\u1b20\0\u1b5e\0\u1b9c\0\370\0\u1bda\0\u1c18\0\u1c56\0\u1c56"+
    "\0\370\0\u1c94\0\u1cd2\0\u1d10\0\u1d4e\0\u1d8c\0\u1dca\0\u1e08"+
    "\0\u1e46\0\u1e84\0\u1ec2\0\u1f00\0\u1f3e\0\u1f7c\0\u1fba\0\u1ff8"+
    "\0\u2036\0\u2074\0\u20b2\0\u20f0\0\u212e\0\u216c\0\u21aa\0\u21e8"+
    "\0\u2226\0\u1c18\0\u1cd2\0\u2264\0\u22a2\0\u22e0\0\u231e\0\u235c"+
    "\0\u239a\0\370\0\u23d8\0\u2416\0\u2454\0\u2492\0\u24d0\0\u250e"+
    "\0\u254c\0\u258a\0\u25c8\0\u2606\0\u2644\0\u2682\0\u26c0\0\u26fe"+
    "\0\u273c";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[177];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\3\3\1\4\5\3\1\5\2\3\20\5\1\6\5\5"+
    "\1\7\2\3\20\5\1\6\5\5\1\3\1\10\1\3"+
    "\42\11\1\12\33\11\14\0\1\13\1\0\1\14\1\0"+
    "\1\15\2\0\1\16\3\0\1\17\2\0\1\20\1\21"+
    "\11\0\1\13\1\0\1\14\1\0\1\15\2\0\1\16"+
    "\3\0\1\17\2\0\1\20\1\21\13\0\1\22\11\0"+
    "\1\13\1\0\1\14\1\0\1\15\2\0\1\16\3\0"+
    "\1\17\2\0\1\20\1\21\11\0\1\13\1\0\1\14"+
    "\1\0\1\15\2\0\1\16\3\0\1\17\2\0\1\20"+
    "\1\21\127\0\1\23\30\0\1\23\40\0\1\13\1\0"+
    "\1\14\1\0\1\15\2\0\1\16\2\0\1\24\1\17"+
    "\2\0\1\20\1\21\11\0\1\13\1\0\1\14\1\0"+
    "\1\15\2\0\1\16\2\0\1\24\1\17\2\0\1\20"+
    "\1\21\25\0\1\13\1\0\1\14\1\0\1\25\2\0"+
    "\1\16\3\0\1\17\2\0\1\20\1\21\11\0\1\13"+
    "\1\0\1\14\1\0\1\25\2\0\1\16\3\0\1\17"+
    "\2\0\1\20\1\21\21\0\1\26\120\0\1\27\30\0"+
    "\1\27\25\0\1\30\7\0\1\31\20\0\1\30\7\0"+
    "\1\31\15\0\1\31\31\0\1\32\30\0\1\32\31\0"+
    "\1\33\30\0\1\33\44\0\1\34\30\0\1\34\50\0"+
    "\1\35\12\0\1\36\15\0\1\35\12\0\1\36\31\0"+
    "\1\37\3\0\1\40\24\0\1\37\3\0\1\40\15\0"+
    "\1\40\43\0\1\41\30\0\1\41\30\0\1\42\30\0"+
    "\1\42\16\0\1\42\27\0\1\32\11\0\1\41\16\0"+
    "\1\32\11\0\1\41\31\0\1\43\30\0\1\43\36\0"+
    "\1\44\30\0\1\44\60\0\1\45\1\0\1\46\26\0"+
    "\1\45\1\0\1\46\4\0\1\45\40\0\1\47\30\0"+
    "\1\47\21\0\1\50\3\0\1\51\24\0\1\50\3\0"+
    "\1\51\25\0\3\52\1\0\1\53\125\0\1\54\30\0"+
    "\1\54\37\0\1\55\30\0\1\55\45\0\1\56\30\0"+
    "\1\56\47\0\1\57\30\0\1\57\6\0\1\57\17\0"+
    "\1\60\30\0\1\60\27\0\3\61\1\0\1\62\1\0"+
    "\1\61\6\0\1\63\5\0\1\64\5\0\1\65\14\0"+
    "\1\63\5\0\1\64\5\0\1\65\7\0\1\64\32\0"+
    "\1\66\30\0\1\66\41\0\1\67\30\0\1\67\16\0"+
    "\1\67\14\0\1\70\30\0\1\70\54\0\1\71\4\0"+
    "\1\71\23\0\1\71\4\0\1\71\10\0\1\71\36\0"+
    "\1\72\30\0\1\72\6\0\1\72\1\0\3\73\1\74"+
    "\3\73\1\75\1\73\1\0\2\73\10\0\1\76\15\0"+
    "\3\73\10\0\1\76\15\0\1\77\2\73\30\0\1\100"+
    "\30\0\1\100\50\0\1\37\30\0\1\37\6\0\1\37"+
    "\2\0\3\52\1\0\1\53\12\0\1\15\11\0\1\101"+
    "\1\102\15\0\1\15\11\0\1\101\1\102\41\0\1\103"+
    "\30\0\1\103\34\0\1\104\30\0\1\104\24\0\3\105"+
    "\1\106\3\105\1\107\1\105\1\0\2\105\1\110\25\0"+
    "\3\105\1\110\25\0\3\105\16\0\1\111\10\0\1\112"+
    "\1\113\16\0\1\111\10\0\1\112\1\113\30\0\1\114"+
    "\3\0\1\114\3\0\1\114\4\0\1\114\13\0\1\114"+
    "\3\0\1\114\3\0\1\114\4\0\1\114\14\0\3\71"+
    "\1\0\1\115\1\0\1\71\4\0\1\13\1\0\1\116"+
    "\10\0\1\17\1\0\1\117\1\120\12\0\1\13\1\0"+
    "\1\116\10\0\1\17\1\0\1\117\1\120\13\0\3\61"+
    "\1\0\1\62\10\0\1\63\13\0\1\65\14\0\1\63"+
    "\13\0\1\65\42\0\1\121\30\0\1\121\40\0\1\122"+
    "\30\0\1\122\15\0\1\122\33\0\1\123\30\0\1\123"+
    "\33\0\1\124\30\0\1\124\36\0\1\125\113\0\1\126"+
    "\30\0\1\126\15\0\3\70\1\0\1\127\10\0\1\116"+
    "\13\0\1\120\14\0\1\116\13\0\1\120\13\0\3\71"+
    "\1\0\1\115\6\0\1\13\1\0\1\116\10\0\1\17"+
    "\2\0\1\120\12\0\1\13\1\0\1\116\10\0\1\17"+
    "\2\0\1\120\26\0\1\71\3\0\1\71\24\0\1\71"+
    "\3\0\1\71\26\0\1\73\73\0\3\73\1\74\5\73"+
    "\1\0\2\73\26\0\3\73\26\0\3\73\26\0\1\130"+
    "\30\0\1\130\32\0\1\131\30\0\1\131\63\0\1\132"+
    "\30\0\1\132\31\0\1\37\30\0\1\37\41\0\1\133"+
    "\30\0\1\133\62\0\1\134\30\0\1\134\13\0\1\105"+
    "\73\0\3\105\1\106\5\105\1\0\2\105\26\0\3\105"+
    "\26\0\3\105\26\0\1\135\30\0\1\135\25\0\1\71"+
    "\10\0\1\136\30\0\1\136\62\0\1\137\30\0\1\137"+
    "\44\0\1\140\30\0\1\140\7\0\3\141\1\0\1\142"+
    "\1\141\33\0\1\143\1\0\1\141\61\0\1\144\30\0"+
    "\1\144\40\0\1\31\30\0\1\31\15\0\1\31\35\0"+
    "\1\145\30\0\1\145\31\0\1\35\30\0\1\35\41\0"+
    "\1\146\30\0\1\146\66\0\1\147\30\0\1\147\35\0"+
    "\1\150\30\0\1\150\44\0\1\151\30\0\1\151\30\0"+
    "\26\152\2\0\1\152\61\0\1\153\30\0\1\153\34\0"+
    "\1\154\3\0\1\154\24\0\1\154\3\0\1\154\15\0"+
    "\1\154\37\0\1\57\30\0\1\57\40\0\1\155\30\0"+
    "\1\155\47\0\1\156\30\0\1\156\6\0\1\156\25\0"+
    "\1\44\30\0\1\44\15\0\1\44\22\0\1\157\3\0"+
    "\1\157\24\0\1\157\3\0\1\157\15\0\1\157\21\0"+
    "\1\160\14\0\1\161\13\0\1\160\14\0\1\161\6\0"+
    "\1\161\27\0\1\162\30\0\1\162\46\0\1\163\30\0"+
    "\1\163\15\0\3\141\1\0\1\142\1\141\7\0\1\164"+
    "\13\0\1\165\1\166\6\0\1\143\1\0\1\141\2\0"+
    "\1\164\13\0\1\165\1\166\41\0\1\167\30\0\1\167"+
    "\42\0\1\170\30\0\1\170\33\0\1\171\30\0\1\171"+
    "\62\0\1\172\1\45\27\0\1\172\1\45\6\0\1\45"+
    "\35\0\1\173\30\0\1\173\6\0\1\173\1\0\3\174"+
    "\1\175\3\174\1\176\1\174\1\0\2\174\10\0\1\177"+
    "\15\0\3\174\10\0\1\177\15\0\1\200\2\174\20\0"+
    "\1\61\3\0\1\61\24\0\1\61\3\0\1\61\15\0"+
    "\1\61\2\0\3\201\1\202\3\201\1\203\1\201\1\0"+
    "\2\201\1\204\25\0\3\201\1\204\25\0\3\201\12\0"+
    "\1\205\1\0\26\152\2\0\1\152\46\0\1\206\30\0"+
    "\1\206\56\0\1\112\1\113\27\0\1\112\1\113\46\0"+
    "\1\207\30\0\1\207\36\0\1\210\30\0\1\210\15\0"+
    "\1\210\36\0\1\45\30\0\1\45\6\0\1\45\23\0"+
    "\1\100\30\0\1\100\40\0\1\211\30\0\1\211\42\0"+
    "\1\30\30\0\1\30\63\0\1\212\30\0\1\212\35\0"+
    "\1\40\30\0\1\40\15\0\1\40\17\0\1\213\30\0"+
    "\1\213\54\0\1\214\30\0\1\214\16\0\1\214\34\0"+
    "\1\215\30\0\1\215\6\0\1\215\21\0\1\216\30\0"+
    "\1\216\56\0\1\217\30\0\1\217\14\0\1\174\73\0"+
    "\3\174\1\175\5\174\1\0\2\174\26\0\3\174\26\0"+
    "\3\174\26\0\1\220\30\0\1\220\20\0\1\201\73\0"+
    "\3\201\1\202\5\201\1\0\2\201\26\0\3\201\26\0"+
    "\3\201\26\0\1\221\30\0\1\221\16\0\2\205\3\0"+
    "\5\205\1\222\27\205\2\0\32\205\34\0\1\223\30\0"+
    "\1\223\6\0\1\223\14\0\1\52\111\0\1\224\30\0"+
    "\1\224\41\0\1\100\30\0\1\100\15\0\1\100\33\0"+
    "\1\225\30\0\1\225\47\0\1\226\30\0\1\226\6\0"+
    "\1\226\31\0\1\227\30\0\1\227\46\0\1\230\30\0"+
    "\1\230\42\0\1\231\30\0\1\231\27\0\1\61\102\0"+
    "\1\232\3\0\1\232\24\0\1\232\3\0\1\232\15\0"+
    "\1\232\22\0\1\233\3\0\1\233\24\0\1\233\3\0"+
    "\1\233\15\0\1\233\13\0\1\234\116\0\1\235\30\0"+
    "\1\235\32\0\1\236\30\0\1\236\42\0\1\111\30\0"+
    "\1\111\60\0\1\237\30\0\1\237\24\0\1\240\76\0"+
    "\1\71\117\0\1\241\30\0\1\241\20\0\1\234\31\0"+
    "\1\242\45\0\1\70\112\0\1\243\30\0\1\243\27\0"+
    "\1\141\116\0\1\244\30\0\1\244\6\0\1\244\21\0"+
    "\1\71\30\0\1\71\61\0\1\45\30\0\1\45\44\0"+
    "\1\245\30\0\1\245\41\0\1\246\30\0\1\246\52\0"+
    "\1\247\30\0\1\247\16\0\1\250\63\0\2\250\3\0"+
    "\5\250\1\251\27\250\2\0\32\250\11\0\1\252\75\0"+
    "\1\252\31\0\1\253\32\0\42\254\1\0\75\254\1\255"+
    "\33\254\10\0\1\256\113\0\1\257\30\0\1\257\43\0"+
    "\1\260\30\0\1\260\16\0\1\260\30\0\1\261\30\0"+
    "\1\261\57\0\1\141\32\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[10106];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\2\0\2\1\1\11\3\1\1\11\1\1\60\0\1\11"+
    "\2\1\1\0\1\1\5\0\1\11\2\1\16\0\1\11"+
    "\45\0\1\11\2\1\1\0\1\1\1\11\2\1\36\0"+
    "\1\11\17\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[177];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S120_Subjects() { }
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S120_Subjects(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 9: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 10: break;
          case 3:
            { annotate(new AnnotationEntity(Entity.SUBJECT), "CIVILE", true, true);
            }
          // fall through
          case 11: break;
          case 4:
            { annotate(new AnnotationEntity(Entity.SUBJECT), "PENALE", true, true);
            }
          // fall through
          case 12: break;
          case 5:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 13: break;
          case 6:
            { annotate(new AnnotationEntity(Entity.SUBJECT), "CIVILE", false, true);
            }
          // fall through
          case 14: break;
          case 7:
            { annotate(new AnnotationEntity(Entity.SUBJECT), "PENALE", false, true);
            }
          // fall through
          case 15: break;
          case 8:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 16: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S120_Subjects [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S120_Subjects scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S120_Subjects(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
